(*
Functional maps as balanced binary trees

D. Monniaux, 2003
Laboratoire d'Informatique de l'Ecole Normale Superieure
*)

Definition create [left : t] [key : key] [data : a] [right : t] :=
  (Node left key data right (S (max (height left) (height right)))).

Lemma create_wf_order :
  (left : t) (k : key) (data : a) (right : t)
  (left_wf : (wf_order left))
  (right_wf : (wf_order right))
  (left_bounded : (bounded_up k left))
  (right_bounded : (bounded_down k right))
  (wf_order (create left k data right)).
Proof.
  Intros.
  Unfold create.
  Apply node_wf_order; Assumption.
Qed.

Lemma create_bounded_down :
  (k : key)
  (l : t)
  (k_add: key) (data_add : a)
  (r : t)
  (Horder : (compare k_add k) = GREATER)
  (Hl : (bounded_down k l))
  (Hr : (bounded_down k r))
  (bounded_down k (create l k_add data_add r)).
Proof.
  Intros.
  Unfold create.
  Apply node_bounded_down.
  Assumption.

  Assumption.

  Assumption.
Qed.

Lemma create_bounded_up :
  (k : key)
  (l : t)
  (k_add: key) (data_add : a)
  (r : t)
  (Horder : (compare k_add k) = LESS)
  (Hl : (bounded_up k l))
  (Hr : (bounded_up k r))
  (bounded_up k (create l k_add data_add r)).
Proof.
  Intros.
  Unfold create.
  Apply node_bounded_up.
  Assumption.

  Assumption.

  Assumption.
Qed.
