(*
Functional maps as balanced binary trees

D. Monniaux, 2003
Laboratoire d'Informatique de l'Ecole Normale Superieure

$Id: map_keys.v,v 1.1 2003/11/11 17:43:45 monniaux Exp $
*)

Require PolyList.

Fixpoint ordered_to_assoc_list_with_tail [tree : t] :
  (list (prod key a)) -> (list (prod key a)) :=
  [tail : (list (prod key a))]
  Cases tree of
  | Empty => tail
  | (Node l x d r h) =>
    (ordered_to_assoc_list_with_tail l
      (cons (pair key a x d)
      (ordered_to_assoc_list_with_tail r tail)))
  end.

Inductive ordered_assoc_list : (list (prod key a)) -> Prop :=
| empty_ordered_assoc_list : (ordered_assoc_list (nil (prod key a)))
| cons_ordered_assoc_list : (x : key) (
   (ordered_assoc_list
